EDIT - bug #10090

Many LIEs in cdmserver log for Team.getCollectorTitleCache()
07/13/2022 07:49 PM - Andreas Mller

Status: Closed Start date:

Priority: Priority14 Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.32

Severity: critical Found in Version:

Description

from int cdmserver (startup.log)

Caused by: org.hibernate.LazyInitializationException: failed to lazily initialize a collection of
role: eu.etaxonomy.cdm.model.agent.Team.teamMembers, could not initialize proxy - no Session

at org.hibernate.collection.internal.AbstractPersistentCollection.throwlLazyInitializationE
xception (AbstractPersistentCollection. java:606) ~[hibernate-core-5.4.33.Final.jar:5.4.33.Final]

at org.hibernate.collection.internal.AbstractPersistentCollection.withTemporarySessionIfNe
eded (AbstractPersistentCollection.java:218) ~[hibernate-core-5.4.33.Final.jar:5.4.33.Final]

at org.hibernate.collection.internal.AbstractPersistentCollection.readSize (AbstractPersist
entCollection.java:162) ~[hibernate-core-5.4.33.Final.jar:5.4.33.Final]

at org.hibernate.collection.internal.PersistentlList.size (PersistentList.java:137) ~[hibern
ate-core-5.4.33.Final.jar:5.4.33.Final]

at eu.etaxonomy.cdm.strategy.cache.agent.TeamDefaultCacheStrategy.getCache (TeamDefaultCach
eStrategy.java:174) ~[cdmlib-model-5.32.0-SNAPSHOT. jar:?]

at eu.etaxonomy.cdm.strategy.cache.agent.TeamDefaultCacheStrategy.getCollectorTitleCache (T
eamDefaultCacheStrategy.java:167) ~[cdmlib-model-5.32.0-SNAPSHOT. jar:?]

at eu.etaxonomy.cdm.strategy.cache.agent.TeamDefaultCacheStrategy.getCollectorTitleCache (T
eamDefaultCacheStrategy.java:1l) ~[cdmlib-model-5.32.0-SNAPSHOT. jar:?]

at eu.etaxonomy.cdm.model.agent.Team.getCollectorTitleCache (Team.java:359) ~[cdmlib-model-
5.32.0-SNAPSHOT. jar:?]

Related issues:
Related to EDIT - bug #9949: doGetSynonymy throws LIE in Mexico Portal Closed

Associated revisions

Revision 2efce339 - 07/13/2022 08:02 PM - Andreas Miiller
ref #10090, ref #10089 try to avoid LIE in TypeDesignationSet

Revision c7ef3e53 - 07/14/2022 07:03 PM - Andreas Miiller
ref #10090 catch LIE in Team.getCollectorTitleCache

Revision 6¢536aa0 - 07/15/2022 02:02 PM - Andreas Miiller

fix #10090 add secsource reference author to the PolytomousKeyNode init strategy

Revision 643e100c - 07/15/2022 03:51 PM - Andreas Miiller
fix #10090 revert init strategy and catch LIE in getCollectorTitleCache()

History

#1 - 07/13/2022 07:51 PM - Andreas Miiller
maybe related to #9949

#2 - 07/13/2022 07:51 PM - Andreas Miiller
- Related to bug #9949: doGetSynonymy throws LIE in Mexico Portal added

#3 - 07/15/2022 02:02 PM - Andreas Miiller
https://dev.e-taxonomy.eu/redmine/issues/9949

- Status changed from New to Resolved

- % Done changed from 0 to 70

Applied in changeset cdmlib|6c536aa028a283ed2041899ac33a13baadibcaeb.

#5 - 07/15/2022 03:33 PM - Andreas Miuller

The reason was a missing property path for secsource authors.

The reason why it happened for collectorTitleCache is that titteCaches are generally not computed if not null (related to #5849) and
nomenclaturalTitleCaches in this test data are protected.

More generally spoken, the secundum authorteam is initialized by TitleAndNameCacheAutolnitializer but not necessarily the team members. Json
serialization later (out of session) will try to read the authorteam bean and this throws an exception when team.getCollectorTitleCache() is called.

The final solution | decided for is now to catch LIEs in team.getCollectorTitleCache() if the precomputed collectorTitleCache is not null. This is
acceptable as we do not expected the collectorTitleCache to be needed in this context and anyway the precomputed collectorTitleCache is correct in
most cases.

#6 - 07/21/2022 04:53 PM - Andreas Miiller

- Assignee changed from Andreas Miiller to Katja Luther

Should be fixed. Please review.

#7 - 07/26/2022 11:11 PM - Andreas Miiller
- Priority changed from Highest to Priority14

#8 - 08/24/2022 02:20 PM - Andreas Miiller
- Status changed from Resolved to Closed
- Assignee changed from Katja Luther to Andreas Mdiller

- % Done changed from 70 to 100
